#!/bin/sh
##
##  docker-passwd
##

pwdfile="@l_prefix@/etc/docker-distribution/docker-registry.pwd"

usage () {
    echo "USAGE: docker-passwd set <username> <password>"
    echo "USAGE: docker-passwd del <username>"
    exit 1
}

if [ $# -eq 0 ]; then
    usage
fi
cmd="$1"; shift
case "$cmd" in
    set )
        if [ $# -lt 2 ]; then
            usage
        fi
        username="$1"; shift
        password="$1"; shift
        password=`@l_prefix@/bin/perl -le 'print crypt("$password", "A0")'`
        exists=`grep "^$username:" $pwdfile`
        if [ ".$exists" != . ]; then
            sed -i -e "s;^$username:.*;$username:$password;" $pwdfile
        else
            echo "$username:$password" >>$pwdfile
        fi
        ;;
    del )
        if [ $# -lt 1 ]; then
            usage
        fi
        username="$1"; shift
        exists=`grep "^$username:" $pwdfile`
        if [ ".$exists" = . ]; then
            echo "ERROR: no such user \"$username\"" 1>&2
            exit 1
        fi
        sed -i -e "/^$username:.*/d" $pwdfile
        ;;
esac

